function sum(a : number, b : number) : number; 
function sum(a : string, b : string) : string;
function sum(a : boolean, b : boolean) : boolean;

function sum(a : any, b : any) : any {
    return a + b;
}

console.log(sum(10,15));
console.log(sum('10','15'));

//(a : any, b : any) => any

let action : (a : number, b : number) => number;

function func1(a : number, b : number) : number {
    return a + b;
}
function func2(a : number, b : number) : number {
    return a * b;
}

action = func1;
console.log(action(10,20));

action = func2;
console.log(action(10,20));



function func3(a : number, b : number, foo : (x : number, y : number) =>  number) : number {
    return foo(a, b);
}


let foo : (x : number, y : number) =>  number;
foo = function(x : number, y : number) : number {
    return x*y;
}

console.log(func3(100,200,foo));

let fooSum : (x : number, y : number) =>  number;
fooSum = function(x : number, y : number) : number {
    return x+y;
}
console.log(func3(100,200,fooSum));


let foo3 = () =>  'hello world';

let foo4 = () =>  {
    return 'hello world'
};

console.log(foo4());


function func5(a : number, b : number, foo : (x : number, y : number) =>  number) : number {
    return foo(a, b);
}

console.log(func5(100,200, (a, b) => { return a + b} ));


let result = a => a+a;
console.log(result(10));
